# ObjectSet Class Reference

`#include <ObjectSet.hh>`

List of all members.

## Public Member Functions
| ObjectSet (SecurityServer *the_server)
| ~ObjectSet ()
ObjectHandle | getObjectInstanceHandle (std::string) const throw (ObjectNotKnown, RTIinternalError)
const char * | getObjectInstanceName (ObjectHandle the_object) const throw (ObjectNotKnown, RTIinternalError)
ObjectClassHandle | getObjectClass (ObjectHandle the_object) const throw (ObjectNotKnown, FederateNotExecutionMember, ConcurrentAccessAttempted, RTIinternalError)
void | changeAttributeTransportationType (ObjectHandle the_object, AttributeHandle *the_attributes, UShort the_size, TransportType the_type) throw (ObjectNotKnown, AttributeNotDefined, AttributeNotOwned, RTIinternalError, InvalidObjectHandle)
void | changeAttributeOrderType (ObjectHandle the_object, AttributeHandle *the_attributes, UShort the_size, TransportType the_type) throw (ObjectNotKnown, AttributeNotDefined, AttributeNotOwned, RTIinternalError, InvalidObjectHandle)
Object * | registerObjectInstance (FederateHandle, ObjectClassHandle, ObjectHandle, std::string) throw (ObjectAlreadyRegistered, ConcurrentAccessAttempted, SaveInProgress, RestoreInProgress, RTIinternalError)
void | deleteObjectInstance (FederateHandle, ObjectHandle, std::string tag) throw (ObjectNotKnown, DeletePrivilegeNotHeld, FederateNotExecutionMember, ConcurrentAccessAttempted, SaveInProgress, RestoreInProgress, RTIinternalError)
FederateHandle | requestObjectOwner (FederateHandle the_federate, ObjectHandle the_object) throw (ObjectNotKnown)
void | killFederate (FederateHandle) throw (RTIinternalError)
bool | isAttributeOwnedByFederate (FederateHandle the_federate, ObjectHandle the_object, AttributeHandle the_attribute) const throw (ObjectNotKnown, AttributeNotDefined, RTIinternalError)
void | queryAttributeOwnership (FederateHandle the_federate, ObjectHandle the_object, AttributeHandle the_attribute) const throw (ObjectNotKnown, AttributeNotDefined, RTIinternalError)
void | negotiatedAttributeOwnershipDivestiture (FederateHandle the_federate, ObjectHandle the_object, AttributeHandle *the_attributes, UShort the_size, const char *the_tag) throw (ObjectNotKnown, AttributeNotDefined, AttributeNotOwned, AttributeAlreadyBeingDivested, RTIinternalError)
void | attributeOwnershipAcquisitionIfAvailable (FederateHandle the_federate, ObjectHandle the_object, AttributeHandle *the_attributes, UShort the_size) throw (ObjectNotKnown, ObjectClassNotPublished, AttributeNotDefined, AttributeNotPublished, FederateOwnsAttributes, AttributeAlreadyBeingAcquired, RTIinternalError)
void | unconditionalAttributeOwnershipDivestiture (FederateHandle the_federate, ObjectHandle the_object, AttributeHandle *the_attributes, UShort the_size) throw (ObjectNotKnown, AttributeNotDefined, AttributeNotOwned, RTIinternalError)
void | attributeOwnershipAcquisition (FederateHandle the_federate, ObjectHandle the_object, AttributeHandle *the_attributes, UShort the_size, const char *the_tag) throw (ObjectNotKnown, ObjectClassNotPublished, AttributeNotDefined, AttributeNotPublished, FederateOwnsAttributes, RTIinternalError)
void | cancelNegotiatedAttributeOwnershipDivestiture (FederateHandle the_federate, ObjectHandle the_object, std::vector< AttributeHandle > &, UShort the_size) throw (ObjectNotKnown, AttributeNotDefined, AttributeNotOwned, AttributeDivestitureWasNotRequested, RTIinternalError)
AttributeHandleSet * | attributeOwnershipReleaseResponse (FederateHandle the_federate, ObjectHandle the_object, std::vector< AttributeHandle > &the_attributes, UShort the_size) throw (ObjectNotKnown, AttributeNotDefined, AttributeNotOwned, FederateWasNotAskedToReleaseAttribute, RTIinternalError)
void | cancelAttributeOwnershipAcquisition (FederateHandle the_federate, ObjectHandle the_object, std::vector< AttributeHandle > &the_attributes, UShort the_size) throw (ObjectNotKnown, AttributeNotDefined, AttributeAlreadyOwned, AttributeAcquisitionWasNotRequested, RTIinternalError)
Object * | getObject (ObjectHandle the_object) const throw (ObjectNotKnown)
## Protected Types
typedef std::map< ObjectHandle, Object *, std::less < ObjectHandle > > | Handle2ObjectMap_t
typedef std::map< std::string, Object *, std::less < std::string > > | Name2ObjectMap_t
typedef Handle2ObjectMap_t::const_iterator | handledO_const_iterator
typedef Name2ObjectMap_t::const_iterator | namedO_const_iterator
## Protected Member Functions
void | sendToFederate (NetworkMessage *msg, FederateHandle the_federate) const
| sendToFederate.
## Protected Attributes
SecurityServer * | server
Handle2ObjectMap_t | OFromHandle
Name2ObjectMap_t | OFromName
MessageBuffer | NM_msgBufSend

## Detailed Description

Definition at line 40 of file ObjectSet.hh.

## Member Typedef Documentation

typedef std::map<ObjectHandle,Object*,std::less<ObjectHandle> > Handle2ObjectMap_t`[protected]`

Definition at line 171 of file ObjectSet.hh.

typedef std::map<std::string,Object*,std::less<std::string> > Name2ObjectMap_t`[protected]`

Definition at line 172 of file ObjectSet.hh.

typedef Handle2ObjectMap_t::const_iterator handledO_const_iterator`[protected]`

Definition at line 173 of file ObjectSet.hh.

typedef Name2ObjectMap_t::const_iterator namedO_const_iterator`[protected]`

Definition at line 174 of file ObjectSet.hh.

## Constructor & Destructor Documentation

ObjectSet | ( | SecurityServer * | the_server | ) |

Definition at line 49 of file ObjectSet.cc.

~ObjectSet | ( |  | ) |

Definition at line 55 of file ObjectSet.cc.

References certi::fedparser::end().

Here is the call graph for this function:

## Member Function Documentation

ObjectHandle getObjectInstanceHandle | ( | std::string | the_name | ) | const throw (ObjectNotKnown, RTIinternalError)

Definition at line 97 of file ObjectSet.cc.

References certi::fedparser::end().

Referenced by ObjectManagement::getObjectInstanceHandle().

Here is the call graph for this function:

const char * getObjectInstanceName | ( | ObjectHandle | the_object | ) | const throw (ObjectNotKnown, RTIinternalError)

Definition at line 114 of file ObjectSet.cc.

References ObjectSet::getObject().

Referenced by ObjectManagement::getObjectInstanceName().

Here is the call graph for this function:

ObjectClassHandle getObjectClass | ( | ObjectHandle | the_object | ) | const throw (ObjectNotKnown, FederateNotExecutionMember, ConcurrentAccessAttempted, RTIinternalError)

Definition at line 124 of file ObjectSet.cc.

References Object::getClass(), and ObjectSet::getObject().

Referenced by ObjectManagement::getObjectClass().

Here is the call graph for this function:

void changeAttributeTransportationType | ( | ObjectHandle | the_object,
|  | AttributeHandle * | the_attributes,
|  | UShort | the_size,
|  | TransportType | the_type |
| ) |  |  | throw (ObjectNotKnown, AttributeNotDefined, AttributeNotOwned, RTIinternalError, InvalidObjectHandle)

Definition at line 67 of file ObjectSet.cc.

void changeAttributeOrderType | ( | ObjectHandle | the_object,
|  | AttributeHandle * | the_attributes,
|  | UShort | the_size,
|  | TransportType | the_type |
| ) |  |  | throw (ObjectNotKnown, AttributeNotDefined, AttributeNotOwned, RTIinternalError, InvalidObjectHandle)

Definition at line 82 of file ObjectSet.cc.

Object * registerObjectInstance | ( | FederateHandle | the_federate,
|  | ObjectClassHandle | the_class,
|  | ObjectHandle | the_object,
|  | std::string | the_name |
| ) |  |  | throw (ObjectAlreadyRegistered, ConcurrentAccessAttempted, SaveInProgress, RestoreInProgress, RTIinternalError)

Definition at line 133 of file ObjectSet.cc.

References certi::fedparser::end().

Referenced by RootObject::registerObjectInstance().

Here is the call graph for this function:

void deleteObjectInstance | ( | FederateHandle | ,
|  | ObjectHandle | the_object,
|  | std::string | tag |
| ) |  |  | throw (ObjectNotKnown, DeletePrivilegeNotHeld, FederateNotExecutionMember, ConcurrentAccessAttempted, SaveInProgress, RestoreInProgress, RTIinternalError)

Definition at line 176 of file ObjectSet.cc.

References ObjectSet::getObject().

Referenced by RootObject::deleteObjectInstance().

Here is the call graph for this function:

FederateHandle requestObjectOwner | ( | FederateHandle | the_federate,
|  | ObjectHandle | the_object |
| ) |  |  | throw (ObjectNotKnown)

Definition at line 442 of file ObjectSet.cc.

References certi::fedparser::end(), certi::G, PrettyDebug::Out(), and pdGendoc.

Referenced by RootObject::requestObjectOwner().

Here is the call graph for this function:

void killFederate | ( | FederateHandle | the_federate | ) | throw (RTIinternalError)

Definition at line 196 of file ObjectSet.cc.

References certi::fedparser::end().

Referenced by RootObject::killFederate().

Here is the call graph for this function:

bool isAttributeOwnedByFederate | ( | FederateHandle | the_federate,
|  | ObjectHandle | the_object,
|  | AttributeHandle | the_attribute |
| ) |  |  | const throw (ObjectNotKnown, AttributeNotDefined, RTIinternalError)

Definition at line 210 of file ObjectSet.cc.

References certi::D, ObjectSet::getObject(), PrettyDebug::Out(), pdDebug, and ObjectSet::server.

Referenced by Federation::isOwner().

Here is the call graph for this function:

void queryAttributeOwnership | ( | FederateHandle | the_federate,
|  | ObjectHandle | the_object,
|  | AttributeHandle | the_attribute |
| ) |  |  | const throw (ObjectNotKnown, AttributeNotDefined, RTIinternalError)

Definition at line 229 of file ObjectSet.cc.

References NetworkMessage::ATTRIBUTE_IS_NOT_OWNED, NM_Factory::create(), certi::D, certi::e_NO_EXCEPTION, NetworkMessage::federate, SecurityServer::federation(), NetworkMessage::federation, ObjectSet::getObject(), ObjectAttribute::getOwner(), NetworkMessage::handleArray, NetworkMessage::INFORM_ATTRIBUTE_OWNERSHIP, NetworkMessage::object, PrettyDebug::Out(), pdDebug, ObjectSet::sendToFederate(), and ObjectSet::server.

Referenced by Federation::queryAttributeOwnership().

Here is the call graph for this function:

void negotiatedAttributeOwnershipDivestiture | ( | FederateHandle | the_federate,
|  | ObjectHandle | the_object,
|  | AttributeHandle * | the_attributes,
|  | UShort | the_size,
|  | const char * | the_tag |
| ) |  |  | throw (ObjectNotKnown, AttributeNotDefined, AttributeNotOwned, AttributeAlreadyBeingDivested, RTIinternalError)

Definition at line 266 of file ObjectSet.cc.

void attributeOwnershipAcquisitionIfAvailable | ( | FederateHandle | the_federate,
|  | ObjectHandle | the_object,
|  | AttributeHandle * | the_attributes,
|  | UShort | the_size |
| ) |  |  | throw (ObjectNotKnown, ObjectClassNotPublished, AttributeNotDefined, AttributeNotPublished, FederateOwnsAttributes, AttributeAlreadyBeingAcquired, RTIinternalError)

Definition at line 282 of file ObjectSet.cc.

void unconditionalAttributeOwnershipDivestiture | ( | FederateHandle | the_federate,
|  | ObjectHandle | the_object,
|  | AttributeHandle * | the_attributes,
|  | UShort | the_size |
| ) |  |  | throw (ObjectNotKnown, AttributeNotDefined, AttributeNotOwned, RTIinternalError)

Definition at line 299 of file ObjectSet.cc.

void attributeOwnershipAcquisition | ( | FederateHandle | the_federate,
|  | ObjectHandle | the_object,
|  | AttributeHandle * | the_attributes,
|  | UShort | the_size,
|  | const char * | the_tag |
| ) |  |  | throw (ObjectNotKnown, ObjectClassNotPublished, AttributeNotDefined, AttributeNotPublished, FederateOwnsAttributes, RTIinternalError)

Definition at line 313 of file ObjectSet.cc.

void cancelNegotiatedAttributeOwnershipDivestiture | ( | FederateHandle | the_federate,
|  | ObjectHandle | the_object,
|  | std::vector< AttributeHandle > & | the_attributes,
|  | UShort | the_size |
| ) |  |  | throw (ObjectNotKnown, AttributeNotDefined, AttributeNotOwned, AttributeDivestitureWasNotRequested, RTIinternalError)

Definition at line 331 of file ObjectSet.cc.

References ObjectAttribute::beingDivested(), certi::D, ObjectSet::getObject(), ObjectAttribute::getOwner(), PrettyDebug::Out(), pdExcept, ObjectSet::server, and ObjectAttribute::setDivesting().

Referenced by Federation::cancelDivestiture().

Here is the call graph for this function:

AttributeHandleSet * attributeOwnershipReleaseResponse | ( | FederateHandle | the_federate,
|  | ObjectHandle | the_object,
|  | std::vector< AttributeHandle > & | the_attributes,
|  | UShort | the_size |
| ) |  |  | throw (ObjectNotKnown, AttributeNotDefined, AttributeNotOwned, FederateWasNotAskedToReleaseAttribute, RTIinternalError)

Definition at line 371 of file ObjectSet.cc.

void cancelAttributeOwnershipAcquisition | ( | FederateHandle | the_federate,
|  | ObjectHandle | the_object,
|  | std::vector< AttributeHandle > & | the_attributes,
|  | UShort | the_size |
| ) |  |  | throw (ObjectNotKnown, AttributeNotDefined, AttributeAlreadyOwned, AttributeAcquisitionWasNotRequested, RTIinternalError)

Definition at line 388 of file ObjectSet.cc.

Object * getObject | ( | ObjectHandle | the_object | ) | const throw (ObjectNotKnown)

Definition at line 403 of file ObjectSet.cc.

References certi::fedparser::end().

Referenced by ObjectSet::cancelNegotiatedAttributeOwnershipDivestiture(), ObjectSet::deleteObjectInstance(), RootObject::getObject(), RootObject::getObjectAttribute(), ObjectSet::getObjectClass(), RootObject::getObjectClassAttribute(), ObjectSet::getObjectInstanceName(), ObjectSet::isAttributeOwnedByFederate(), and ObjectSet::queryAttributeOwnership().

Here is the call graph for this function:

void sendToFederate | ( | NetworkMessage * | msg,
|  | FederateHandle | the_federate |
| ) |  |  | const`[protected]`

sendToFederate.

Definition at line 418 of file ObjectSet.cc.

References certi::BEST_EFFORT, certi::D, SecurityServer::getSocketLink(), ObjectSet::NM_msgBufSend, PrettyDebug::Out(), pdExcept, NetworkMessage::send(), and ObjectSet::server.

Referenced by ObjectSet::queryAttributeOwnership().

Here is the call graph for this function:

## Member Data Documentation

SecurityServer* server`[protected]`

Definition at line 169 of file ObjectSet.hh.

Referenced by ObjectSet::cancelNegotiatedAttributeOwnershipDivestiture(), ObjectSet::isAttributeOwnedByFederate(), ObjectSet::queryAttributeOwnership(), and ObjectSet::sendToFederate().

Handle2ObjectMap_t OFromHandle`[protected]`

Definition at line 175 of file ObjectSet.hh.

Name2ObjectMap_t OFromName`[protected]`

Definition at line 176 of file ObjectSet.hh.

MessageBuffer NM_msgBufSend`[protected]`

Definition at line 178 of file ObjectSet.hh.

Referenced by ObjectSet::sendToFederate().

The documentation for this class was generated from the following files:

- ObjectSet.hh
- ObjectSet.cc